## ukui-session-manager 4.0.0.1

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.1.0)
project(ukui-session-manager)

# Find includes in corresponding build directories
set(CMAKE_INCLUDE_CURRENT_DIR ON)
# Instruct CMake to run moc automatically when needed
set(CMAKE_AUTOMOC ON)
# Handle the Qt rcc code generator automatically.
set(CMAKE_AUTORCC ON)
# Create code from a list of Qt designer ui files
set(CMAKE_AUTOUIC ON)

set(CMAKE_CXX_STANDARD 11)

include(GNUInstallDirs)

# Enable funcion names and line numbers even for release builds
add_definitions("-DQT_MESSAGELOGCONTEXT")

# Find the QtWidgets library
find_package(Qt5 COMPONENTS Widgets Core Multimedia X11Extras REQUIRED)
find_package(Qt5LinguistTools)
find_package(KF5IdleTime)
find_package(Qt5DBus)
find_package(KF5CoreAddons)
find_package(KF5Config)
find_package(KF5WindowSystem)

# For debug: cmake -DCMAKE_BUILD_TYPE=debug
set(CMAKE_CXX_FLAGS_DEBUG "-g -O0")
set(CMAKE_C_FLAGS_DEBUG "-g -O0")

# i18n
set(UKUI_TRANSLATIONS_DIR ${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_DATAROOTDIR}/ukui/translations)
add_definitions(
    -DUKUI_TRANSLATIONS_DIR="${UKUI_TRANSLATIONS_DIR}"
)
if (NOT DEFINED UPDATE_TRANSLATIONS)
    set(UPDATE_TRANSLATIONS "No")
endif()

# To create a new ts file: lupdate -recursive . -target-language en_US -ts translations/en_US.ts -no-ui-lines
file(GLOB TS_FILES "${CMAKE_CURRENT_SOURCE_DIR}/translations/*.ts")

# cmake -DUPDATE_TRANSLATIONS=yes
if (UPDATE_TRANSLATIONS)
    qt5_create_translation(QM_FILES ${CMAKE_SOURCE_DIR} ${TS_FILES})
else()
    qt5_add_translation(QM_FILES ${TS_FILES})
endif()
add_custom_target(translations ALL DEPENDS ${QM_FILES})
install(FILES ${QM_FILES} DESTINATION ${UKUI_TRANSLATIONS_DIR}/${PROJECT_NAME})

add_subdirectory(ukui-session)
add_subdirectory(tools)
add_subdirectory(ukuismserver)
add_subdirectory(data)

=== tools/CMakeLists.txt ===
find_package(PkgConfig)
find_package(KF5Screen)
find_package(KF5Wayland)

include_directories(${KF5Wayland_LIBRARIES})
pkg_check_modules(KScreen REQUIRED kscreen2)

set(tools_SRCS
    main.cpp
    ukuipower.cpp
    powerprovider.cpp
    mainwindow.h
    mainwindow.cpp
    grab-x11.cpp
    grab-x11.h
    xeventmonitor.cpp
    xeventmonitor.h
    loginedusers.h
    lockchecker.h
    lockchecker.cpp
    loginedusers.cpp
    ../ukui-session/xdgdirs.cpp
    ../ukui-session/xdgdesktopfile.cpp
    myiconlabel.cpp
    myiconlabel.h
    mypushbutton.cpp
    mypushbutton.h
    pushbutton.cpp
    pushbutton.h
    commonpushbutton.cpp
    commonpushbutton.h
    plasma-shell-manager.cpp
    plasma-shell-manager.h
    mylistview.cpp
    mylistview.h
    ukuilockinfo.h
    ukuilockinfo.cpp
    ../ukui-session/xdgdesktopfile.h
    ../ukui-session/xdgdesktopfile.cpp
    ../ukui-session/xdgdirs.h
    ../ukui-session/xdgdirs.cpp
    ../ukui-session/xdgmacros.h
)

find_package(PkgConfig)
pkg_search_module(GSETTINGS_QT REQUIRED gsettings-qt)
include_directories(${GSETTINGS_QT_INCLUDES})

pkg_check_modules(GLIB2 REQUIRED glib-2.0)
pkg_check_modules(GIO2 REQUIRED gio-2.0)

include_directories(${GLIB2_INCLUDE_DIRS})
include_directories(${GIO2_INCLUDE_DIRS})

add_executable(ukui-session-tools ${tools_SRCS})

target_link_libraries(ukui-session-tools
    Qt5::Widgets
    Qt5::Core
    Qt5::Gui
    Qt5::DBus
    Qt5::Multimedia
    Qt5::X11Extras
    ${GSETTINGS_QT_LIBRARIES}
    ${KF5Wayland_LIBRARIES}
    ${GLIB2_LIBRARIES}
    ${GIO2_LIBRARIES}
    -lxcb
    -lX11
    -lXtst
    -lukui-log4qt
    KF5::WaylandServer
    KF5::WaylandClient
    KF5::Screen
)

install(TARGETS
        ukui-session-tools
        DESTINATION bin)

=== debian/changelog ===
ukui-session-manager (4.0.0.1-1ubuntu2) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 31 Mar 2024 17:23:22 +0000

ukui-session-manager (4.0.0.1-1ubuntu1) noble; urgency=medium

  * Revert introduction of hard dependency on ukui-themes, restoring
    ubuntukylin-theme alternative.  LP: #2058854.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sun, 24 Mar 2024 19:58:21 +0000

ukui-session-manager (4.0.0.1-1build2) noble; urgency=medium

  * No-change rebuild against libqt5core5t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Fri, 15 Mar 2024 07:23:54 +0000

ukui-session-manager (4.0.0.1-1build1) noble; urgency=medium

  * No-change rebuild against libglib2.0-0t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Fri, 08 Mar 2024 07:13:59 +0000

ukui-session-manager (4.0.0.1-1) unstable; urgency=medium

  * New upstream release.

 -- handsome_feng <jianfengli@ubuntukylin.com>  Tue, 27 Feb 2024 09:35:45 +0800

ukui-session-manager (4.0.0.0-1) unstable; urgency=medium

  * New upstream release.
  * Upload to unstable.

 -- handsome_feng <jianfengli@ubuntukylin.com>  Tue, 23 Jan 2024 11:37:51 +0800

=== debian/control ===
Source: ukui-session-manager
Section: x11
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Kylin Team <team+kylin@tracker.debian.org>
Uploaders: Aron Xu <aron@debian.org>,
           handsome_feng <jianfengli@ubuntukylin.com>,
           xibowen <xibowen@kylinos.cn>
Build-Depends: cmake,
               debhelper-compat (= 13),
               libglib2.0-dev,
               libgsettings-qt-dev,
               libkf5config-dev,
               libkf5coreaddons-dev,
               libkf5idletime-dev,
               libkf5screen-dev,
               libkf5wayland-dev,
               libkf5windowsystem-dev,
               libqt5x11extras5-dev,
               libsm-dev,
               libukui-log4qt-dev,
               libx11-dev,
               libxtst-dev,
               pkg-config,
               qtbase5-dev,
               qtmultimedia5-dev,
               qttools5-dev,
               qttools5-dev-tools,
               xdg-user-dirs
Rules-Requires-Root: no
Standards-Version: 4.6.1.0
Homepage: https://gitee.com/openkylin/ukui-session-manager
Vcs-Git: https://gitee.com/openkylin/ukui-session-manager.git
Vcs-Browser: https://gitee.com/openkylin/ukui-session-manager

Package: ukui-session-manager
Architecture: any
Depends: libglib2.0-bin,
         libqt5multimedia5-plugins,
         python3,
         ubuntukylin-theme | ukui-themes,
         ${misc:Depends},
         ${shlibs:Depends}
Recommends: peony,
            ukui-kwin-x11 | ukwm,
            ukui-panel,
            ukui-polkit,
            ukui-screensaver,
            ukui-settings-daemon
Provides: x-session-manager
Description: Session manager of the UKUI desktop environment
 This package contains a session that can be started from a display
 manager such as lightdm. It will load all necessary applications for
 a full-featured user session.
 .
 This package contain the session manager component.

## ukui-session-manager 4.0.0.2

=== tools/CMakeLists.txt ===
--- 
+++ 
@@ -1,9 +1,7 @@
 find_package(PkgConfig)
-find_package(KF5Screen)
 find_package(KF5Wayland)
 
 include_directories(${KF5Wayland_LIBRARIES})
-pkg_check_modules(KScreen REQUIRED kscreen2)
 
 set(tools_SRCS
     main.cpp
@@ -71,7 +69,6 @@
     -lukui-log4qt
     KF5::WaylandServer
     KF5::WaylandClient
-    KF5::Screen
 )
 
 install(TARGETS

=== debian/changelog ===
ukui-session-manager (4.0.0.2-1) unstable; urgency=medium

  * New upstream release.
  * d/control: drop libkf5screen-dev, and pkg-config -> pkgconf.
    (Closes: #1089800)

 -- handsome_feng <jianfengli@ubuntukylin.com>  Mon, 14 Apr 2025 16:28:34 +0800

## ukui-session-manager 4.0.0.3

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-cmake_minimum_required(VERSION 3.1.0)
+cmake_minimum_required(VERSION 3.5)
 project(ukui-session-manager)
 
 # Find includes in corresponding build directories

=== data/CMakeLists.txt ===
file(GLOB SESSION_FILES_IN ukui.desktop)

install(FILES ${SESSION_FILES_IN} DESTINATION "${CMAKE_INSTALL_PREFIX}/share/xsessions")

install(FILES org.ukui.session.gschema.xml DESTINATION "${CMAKE_INSTALL_PREFIX}/share/glib-2.0/schemas")

install(FILES logout.wav weakup.wav startup.wav shutdown.wav DESTINATION "${CMAKE_INSTALL_PREFIX}/share/ukui/ukui-session-manager")

install(DIRECTORY images DESTINATION "${CMAKE_INSTALL_PREFIX}/share/ukui/ukui-session-manager")

install(DIRECTORY config DESTINATION "${CMAKE_INSTALL_PREFIX}/share/ukui/ukui-session-manager")

install(FILES ukui-session-tools.desktop DESTINATION "${CMAKE_INSTALL_PREFIX}/share/applications")

install(PROGRAMS clean_all_jobs.py DESTINATION "${CMAKE_INSTALL_SYSCONFDIR}/ukui/ukui-session/logout")

install(FILES com.ubuntu.enable-hibernate.pkla DESTINATION "${CMAKE_INSTALL_SYSCONFDIR}/polkit-1/localauthority/50-local.d")

install(FILES 99ukui-environment DESTINATION "${CMAKE_INSTALL_SYSCONFDIR}/X11/Xsession.d")

=== ukui-session/CMakeLists.txt ===
# Populate a CMake variable with the sources
set(ukui-session_SRCS
    main.cpp
    sessionapplication.cpp
    modulemanager.cpp
    ukuimodule.cpp
    idlewatcher.cpp
    sessiondbusadaptor.h
    idlewatcher.cpp
    idlewatcher.h
    idleadbusdaptor.h
    xdgautostart.cpp
    xdgautostart.h
    xdgdesktopfile.cpp
    xdgdesktopfile.h
    xdgdirs.cpp
    xdgdirs.h
    xdgmacros.h
    usminhibit.cpp
    usminhibit.h
    ../tools/ukuipower.cpp
    ../tools/powerprovider.cpp
    ukuisessiondebug.cpp
    ukuisessiondebug.h
    sessionmanagercontext.h
    sessionmanagercontext.cpp
    ukuilockinfo.cpp
)

#find_package(QT5XDG )
find_package(PkgConfig)
pkg_search_module(GSETTINGS_QT REQUIRED gsettings-qt)
include_directories(${GSETTINGS_QT_INCLUDES})

pkg_check_modules(GLIB2 REQUIRED glib-2.0)
pkg_check_modules(GIO2 REQUIRED gio-2.0)

pkg_search_module(X11 REQUIRED x11)
pkg_check_modules(KDKINFO kysdk-sysinfo)
if (KDKINFO_FOUND)
    ADD_DEFINITIONS(-DKDKINFO_FOUND="true")
endif()

include_directories(${X11_INCLUDES})
include_directories(${GLIB2_INCLUDE_DIRS})
include_directories(${GIO2_INCLUDE_DIRS})
include_directories(${KDKINFO_INCLUDE_DIRS})

link_directories(${KDKINFO_LIBRARY_DIRS})

add_executable(ukui-session ${ukui-session_SRCS})
target_link_libraries(ukui-session
    Qt5::Widgets
    Qt5::Core
    Qt5::DBus
    Qt5::Multimedia
    KF5::IdleTime
    KF5::CoreAddons
    KF5::ConfigCore
    KF5::ConfigGui
    KF5::WindowSystem
    -lSM -lICE
    ${GSETTINGS_QT_LIBRARIES} ${X11_LIBRARIES}
    ${GLIB2_LIBRARIES}
    ${GIO2_LIBRARIES}
    ${KDKINFO_LIBRARIES})
#${GSETTINGS_QT_LIBRARIES}

install(TARGETS ukui-session DESTINATION bin)

=== ukuismserver/CMakeLists.txt ===
set(UKUISMSERVER_SRCS
    main.cpp
    ukuismclient.cpp
    ukuismclient.h
    ukuismserver.cpp
    ukuismserver.h
    ukuismserverdebug.cpp
    ukuismserverdebug.h
    ukuismconnection.h
    ukuismserverdbusadaptor.cpp
    ukuismserverdbusadaptor.h
)

qt5_add_dbus_interface(UKUISMSERVER_SRCS org.ukui.KWin.Session.xml ukuikwinsession_interface)

add_executable(ukuismserver ${UKUISMSERVER_SRCS})
target_link_libraries(ukuismserver PRIVATE Qt5::Widgets Qt5::DBus KF5::WindowSystem KF5::ConfigCore
                      KF5::ConfigGui KF5::CoreAddons -lSM -lICE)

install(TARGETS ukuismserver DESTINATION bin)

=== debian/changelog ===
ukui-session-manager (4.0.0.3-1) unstable; urgency=medium

  * Set minimum CMake version to 3.5 to fix FTBFS with CMake 4.
    (Closes: #11136022)

 -- handsome_feng <jianfengli@ubuntukylin.com>  Mon, 03 Nov 2025 18:12:11 +0800

=== debian/control ===
--- 
+++ 
@@ -1,8 +1,7 @@
 Source: ukui-session-manager
 Section: x11
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Kylin Team <team+kylin@tracker.debian.org>
+Maintainer: Kylin Team <team+kylin@tracker.debian.org>
 Uploaders: Aron Xu <aron@debian.org>,
            handsome_feng <jianfengli@ubuntukylin.com>,
            xibowen <xibowen@kylinos.cn>
@@ -13,7 +12,6 @@
                libkf5config-dev,
                libkf5coreaddons-dev,
                libkf5idletime-dev,
-               libkf5screen-dev,
                libkf5wayland-dev,
                libkf5windowsystem-dev,
                libqt5x11extras5-dev,
@@ -21,7 +19,7 @@
                libukui-log4qt-dev,
                libx11-dev,
                libxtst-dev,
-               pkg-config,
+               pkgconf,
                qtbase5-dev,
                qtmultimedia5-dev,
                qttools5-dev,
@@ -38,7 +36,7 @@
 Depends: libglib2.0-bin,
          libqt5multimedia5-plugins,
          python3,
-         ubuntukylin-theme | ukui-themes,
+         ukui-themes,
          ${misc:Depends},
          ${shlibs:Depends}
 Recommends: peony,

=== debian/rules ===
#!/usr/bin/make -f

DEB_HOST_ARCH_OS ?= $(shell dpkg-architecture -qDEB_HOST_ARCH_OS)
export LC_ALL=C.UTF-8
export DEB_BUILD_MAINT_OPTIONS = hardening=+all
export DEB_BUILD_HARDENING_FORTY=2 -O2

ifeq ($(DEB_HOST_ARCH_OS),linux)
    CMAKE_ARGS += -DWITH_LIBUDEV=ON
else
    CMAKE_ARGS += -DWITH_LIBUDEV=OFF
endif

%:
	dh ${@} --buildsystem cmake

override_dh_auto_configure:
	dh_auto_configure -- \
		-DCMAKE_BUILD_TYPE=RelWithDebInfo \
		$(CMAKE_ARGS)

=== debian/watch ===
version=4
https://github.com/ukui/ukui-session-manager/releases .*/ukui-session-manager_(\d\S+)\.orig\.tar\.gz
